{{/* 
    
    PlantUML Configuration parsing 

    Context: (dict
        "berichtNaam" 
        "berichtDiagram"
    )

*/}}

{{ $baseURL := site.BaseURL }}
{{ $bookSection := site.Params.BookSection }}
{{ $handwritten := site.Params.PlantUML.skinparam.handwritten }}
{{ $checked := "" }}
{{ if (site.Params.PlantUML.skinparam.handwritten) }}
    {{ $checked = "checked" }}
{{ end }}
{{ $docsURL := partial "kroki/docs-url" (dict 
    "baseURL" $baseURL 
    "bookSection" $bookSection 
) }}
{{ $plantUmlConfigTemplate := `
    !theme <%= theme %>
    skinparam handwritten <%= handwritten %>
    hide methods
    hide circles
` }}

<p>
    <strong>Selecteer PlantUML Theme: </strong>
    <select id="PlantUML:Theme" onchange="plantUMLConfigChanged()">
    {{ range $themeOption := site.Params.PlantUML.themeOptions }}
        <option value={{ $themeOption }}>{{ $themeOption }}</option>
    {{ end }}
    </select>
</p>
<p>
    <strong>Handgeschreven: </strong>
    <input type="checkbox" id="PlantUML:Handwritten" name="handwritten" onchange="plantUMLConfigChanged()" {{ $checked }}>
</p>

<script>

    function plantUMLConfigChanged() {
        const themeValue = document.getElementById('PlantUML:Theme').value;
        const handwrittenChecked = document.getElementById('PlantUML:Handwritten').checked;
        console.log(themeValue);
        console.log(handwrittenChecked);
        const plantUmlConfig = '{{ $plantUmlConfigTemplate }}'
            .replace('<%= theme %>', themeValue)
            .replace('<%= handwritten %>', handwrittenChecked);
        console.log(plantUmlConfig);
        renderKrokiDiagram(
            '{{ .berichtNaam }}', 
            'plantuml', 
            '{{ .berichtDiagram }}'
                .replace('<%= plantUmlConfig %>', plantUmlConfig), 
            '{{ $docsURL }}');
    }
    
</script>